extern "C" {

/*
===============================================================================

 C.Basic for CG ver 0.10

 copyright(c)2015/2016/2017 by sentaro21
 e-mail sentaro21@pm.matrix.jp

===============================================================================
*/
#include "prizm.h"
#include "CBP.h"
#include "SH7305_CPG_BSC.h"
#include "Ptune2_direct.h"

//----------------------------------------------------------------------------------------------

#define P7305_EXTRA_TMU5_COUNT 0xA44D00D8
int BenchDD() {
	int TMU5_COUNT;
	TMU5_COUNT = *(unsigned int*)P7305_EXTRA_TMU5_COUNT;
	Bdisp_PutDisp_DD();
	TMU5_COUNT = TMU5_COUNT - *(unsigned int*)P7305_EXTRA_TMU5_COUNT ;
	return 3276800/TMU5_COUNT;
}

void CG20_overclock(){
	if ( BenchDD() < 5000 ) {	//  < 50fps
		LoadDataF3();	// 118MHz
	}
	/*
	if ( 
		( BSC.CS0WCR.BIT.WR == WAIT_3 ) &&
		( BSC.CS2WCR.BIT.WR == WAIT_2 ) &&
		( CPG.FLLFRQ.LONG   == FLLFRQ_default ) &&
		( CPG.FRQCRA.LONG   == FRQCRA_default ) &&
		( BSC.CS0BCR.LONG   == CS0BCR_default ) &&
		( BSC.CS2BCR.LONG   == CS2BCR_default ) &&
		( BSC.CS0WCR.LONG   == CS0WCR_default ) &&
		( BSC.CS2WCR.LONG   == CS2WCR_default ) &&
		( BSC.CS5ABCR.LONG  == CS5aBCR_default ) &&
		( BSC.CS5AWCR.LONG  == CS5aWCR_default ) ) {
		LoadDataF3();	// 118MHz
	}
	*/
}

//****************************************************************************
void G3A_main( void ){
	int key;
	char *ptr,*stat;
	int i,j;

	char *src;
	char filename[128];
	char wbuf[0x40000+16];	// work buffer	256KB
	char clipbuffer[CLIPMAX2+1+4];

	EnableColor( 1 );
	SetVeiwWindowInit();
	for ( i=0; i<6; i++) VWinflag[i]=0;
//	Previous_X=1e308; Previous_Y=1e308; 	// ViewWindow Previous XY init
//	Previous_PX=-1;   Previous_PY=-1; 		// ViewWindow Previous PXY init
	LoadConfig();
	CB_INT=0;	// double mode default
	
	PictAry[0]=(unsigned char*)GetVRAMAddress();
	IsCG20=0;	// CG50
	if ( (int)PictAry[0] != 0xAC000000 ) {
		IsCG20=1;	// CG10/20
		IsHiddenRAM=0;
		CG20_overclock();
	}
	HiddenRAM();	// Check HiddenRAM

//	HiddenRAM_MatAryStore();	// MatAry ptr -> HiddenRAM
	HiddenRAM_MatAryInit();	// HiddenRAM Initialize

	
	TVRAM = (char*)PictAry[0]+0x000F0000;
//	TVRAM = PictAry[0]+0x00200000;
//	TVRAM = (char *)malloc( 2048+4 );
//	if ( TVRAM == NULL )  { CB_ErrMsg(MemoryERR); return 1 ; }

	GVRAM = TVRAM+0x28800;
	memset( GVRAM, 0xFFFF, 0x28800);
	BufVRAM = (char*)GetVRAMWorkBuffer();
	memset( BufVRAM, 0, 0x28800);
	WorkBuf = (char*)( (unsigned int)wbuf & 0xFFFFFFF0 )+16;
	PictBuf = GVRAM;
//	GVRAM = TVRAM+1024;;
//	if ( TVRAM == NULL )  { CB_ErrMsg(MemoryERR); return 1 ; }

	ClipBuffer = clipbuffer;		// stack
//	ClipBuffer = (char *)malloc( ClipMax+1+4 );		// normal heap
//	if ( ClipBuffer == NULL )  { CB_ErrMsg(MemoryERR); return 1 ; }

	traceAry = (double *)malloc( 386*8+4 );
//	if ( traceAry == NULL )  { CB_ErrMsg(MemoryERR); return 1 ; }

//	if ( StorageMode ) StorageMode = CheckSD() ; // SD mode
	
	StoPict( 1 );	// pre malloc ( pict 1 array )
	
//	storeFile( "\\\\fls0\\@@@check.bin", (unsigned char*)ClipBuffer, 16 );
//	CB_SaveSub( "/@check.bin", ClipBuffer, 16, 0, "bin" );
//	DeleteFile( "\\\\fls0\\@check.bin" );

	ProgNo=0;
	strncpy(ProgfileAdrs[ProgNo]+0x3C,(const char*)"",8);

	while (1) {
		for (i=0; i<=ProgMax; i++) {
			ProgfileAdrs[i]=NULL;	// Prog Entry clear
			ProgfileEdit[i]=0;		// Prog Edit flag clear
			for (j=0; j<26; j++)	ProgLocalVar[i][j]=-1;
		}

		CB_BackPict=0;				// back image
		CB_ColorIndex=-1;				// current color index reset
		CB_BackColorIndex=0xFFFF;		// Back color index (default White)
		InitLocalVar();		// init Local variable
		CB_AliasVarClr();
		ExecPtr=0;	
		DebugMode=0;
		DebugScreen=0;
		ForceDebugMode=0;
		ForceReturn=0;
		
		PictbasePtr=-1;
		PictbaseCount=PictbaseCountMAX;
		for (i=1; i<=PictMax; i++) {
			if ( !( (UseHiddenRAM&0xF0) && ( UseHiddenRAM ) && ( IsHiddenRAM ) ) )
			PictAry[i]=NULL;		// Pict ptr clear
		}
		
		key =( SelectFile( filename ) ) ;
		switch ( key ) {
			case FileCMD_DebugRUN:
				DebugMode=9; // debug mode start
				ForceDebugMode=1;
			case FileCMD_RUN_F1:
				if ( ForceReturnMode & 1 ) ForceReturn=1;
				goto runjp;
			case FileCMD_RUN:
//			case KEY_CTRL_EXE:
				if ( ForceReturnMode & 2 ) ForceReturn=1;
		runjp:
				i=LoadProgfile( filename, 0, EditMaxfree, 1 ) ;
				if ( i==0 )	{
					PP_ReplaceCode( ProgfileAdrs[0] + 0x56 );	//
					ExecPtr=0;
					EditRun(1);			// Program run
				}else
				if ( i==NotfoundProgERR ) { ProgNo=ErrorProg; ExecPtr=ErrorPtr; if (ProgNo>=0) EditRun(2); }	// Program listing & edit
				break;
			case FileCMD_EDIT:
				ExecPtr=0;
				i=LoadProgfile( filename, 0, EditMaxfree, 1 ) ;
				if ( i==0 )	{
					PP_ReplaceCode( ProgfileAdrs[0] + 0x56 );	//
					ExecPtr=0;
					EditRun(2);			// Program listing & edit
				} else
				if ( i==NotfoundProgERR ) { ProgNo=ErrorProg; ExecPtr=ErrorPtr; if (ProgNo>=0) EditRun(2); }	// Program listing & edit
				break;
			case FileCMD_NEW:
				if ( NewProg() ) break ;
				EditRun(2);			// Program listing & edit
				break;
			case FileCMD_RENAME:
				RenameCopyFile(filename, 0);
				break;
			case FileCMD_DEL:
				DeleteFileFav(filename, 1);
				break;
			case FileCMD_COPY:
				RenameCopyFile(filename, 1);
				break;
			case FileCMD_TEXT:
				ConvertToText(filename);
				break;
			case FileCMD_PASS:
				NewPassWord(filename);
				break;
//			case FileCMD_MKDIR:
//				MakeDirectory();
//				break;
//			case FileCMD_RENDIR:
//				RenameDirectorys(filename);
//				break;
			default:
				break;
		}
		SaveConfig();
		
		CB_ColorIndex=-1;				// current color index reset
		CB_BackColorIndex=0xFFFF;		// Back color index (default White)
		for (i=ProgMax; i>=0; i--) {			// memory free
			if ( ProgfileEdit[i] ) SaveProgfile(i);	// edited file ?
			ptr=ProgfileAdrs[i];
			if ( ptr != NULL ) 
				HiddenRAM_freeProg(ptr);
			ProgfileAdrs[i]=NULL;
		}
//		for (i=PictbaseMAX-1; i>=0; i--) {			// Pict memory free
//			ptr=(char*)Pictbase[i];
//			if ( ptr != NULL )
//				free(ptr);
//			Pictbase[i]=NULL;
//		}
	}
}


#pragma section _BR_Size
unsigned long BR_Size;
#pragma section

}

